Index: issm/trunk/src/m/classes/amr.py
===================================================================
--- issm/trunk/src/m/classes/amr.py	(revision 25994)
+++ issm/trunk/src/m/classes/amr.py	(revision 26744)
@@ -5,6 +5,5 @@
 
 class amr(object):
-    """
-    AMR Class definition
+    """AMR Class definition
 
     Usage:
@@ -12,75 +11,85 @@
     """
 
-    def __init__(self):  # {{{
-        self.hmin = 0.
-        self.hmax = 0.
+    def __init__(self): #{{{
+        self.hmin = 0
+        self.hmax = 0
         self.fieldname = ''
-        self.err = 0.
-        self.keepmetric = 0.
-        self.gradation = 0.
-        self.groundingline_resolution = 0.
-        self.groundingline_distance = 0.
-        self.icefront_resolution = 0.
-        self.icefront_distance = 0.
-        self.thicknesserror_resolution = 0.
-        self.thicknesserror_threshold = 0.
-        self.thicknesserror_groupthreshold = 0.
-        self.thicknesserror_maximum = 0.
-        self.deviatoricerror_resolution = 0.
-        self.deviatoricerror_threshold = 0.
-        self.deviatoricerror_groupthreshold = 0.
-        self.deviatoricerror_maximum = 0.
-        self.restart = 0.
-    #set defaults
+        self.err = 0
+        self.keepmetric = 0
+        self.gradation = 0
+        self.groundingline_resolution = 0
+        self.groundingline_distance = 0
+        self.icefront_resolution = 0
+        self.icefront_distance = 0
+        self.thicknesserror_resolution = 0
+        self.thicknesserror_threshold = 0
+        self.thicknesserror_groupthreshold = 0
+        self.thicknesserror_maximum = 0
+        self.deviatoricerror_resolution = 0
+        self.deviatoricerror_threshold = 0
+        self.deviatoricerror_groupthreshold = 0
+        self.deviatoricerror_maximum = 0
+        self.restart = 0
+
         self.setdefaultparameters()
     #}}}
 
-    def __repr__(self):  # {{{
-        string = "   amr parameters:"
-        string = "%s\n%s" % (string, fielddisplay(self, "hmin", "minimum element length"))
-        string = "%s\n%s" % (string, fielddisplay(self, "hmax", "maximum element length"))
-        string = "%s\n%s" % (string, fielddisplay(self, "fieldname", "name of input that will be used to compute the metric (should be an input of FemModel)"))
-        string = "%s\n%s" % (string, fielddisplay(self, "keepmetric", "indicates whether the metric should be kept every remeshing time"))
-        string = "%s\n%s" % (string, fielddisplay(self, "gradation", "maximum ratio between two adjacent edges"))
-        string = "%s\n%s" % (string, fielddisplay(self, "groundingline_resolution", "element length near the grounding line"))
-        string = "%s\n%s" % (string, fielddisplay(self, "groundingline_distance", "distance around the grounding line which elements will be refined"))
-        string = "%s\n%s" % (string, fielddisplay(self, "icefront_resolution", "element length near the ice front"))
-        string = "%s\n%s" % (string, fielddisplay(self, "icefront_distance", "distance around the ice front which elements will be refined"))
-        string = "%s\n%s" % (string, fielddisplay(self, "thicknesserror_resolution", "element length when thickness error estimator is used"))
-        string = "%s\n%s" % (string, fielddisplay(self, "thicknesserror_threshold", "maximum threshold thickness error permitted"))
-        string = "%s\n%s" % (string, fielddisplay(self, "thicknesserror_groupthreshold", "maximum group threshold thickness error permitted"))
-        string = "%s\n%s" % (string, fielddisplay(self, "thicknesserror_maximum", "maximum thickness error permitted"))
-        string = "%s\n%s" % (string, fielddisplay(self, "deviatoricerror_resolution", "element length when deviatoric stress error estimator is used"))
-        string = "%s\n%s" % (string, fielddisplay(self, "deviatoricerror_threshold", "maximum threshold deviatoricstress error permitted"))
-        string = "%s\n%s" % (string, fielddisplay(self, "deviatoricerror_groupthreshold", "maximum group threshold deviatoric stress error permitted"))
-        string = "%s\n%s" % (string, fielddisplay(self, "deviatoricerror_maximum", "maximum deviatoricstress error permitted"))
-        string = "%s\n%s" % (string, fielddisplay(self, "restart", "indicates if ReMesh() will call before first time step"))
-        return string
+    def __repr__(self): #{{{
+        s = '   amr parameters:\n'
+        s += '{}\n'.format(fielddisplay(self, 'hmin', 'minimum element length'))
+        s += '{}\n'.format(fielddisplay(self, 'hmax', 'maximum element length'))
+        s += '{}\n'.format(fielddisplay(self, 'fieldname', 'name of input that will be used to compute the metric (should be an input of FemModel)'))
+        s += '{}\n'.format(fielddisplay(self, 'keepmetric', 'indicates whether the metric should be kept every remeshing time'))
+        s += '{}\n'.format(fielddisplay(self, 'gradation', 'maximum ratio between two adjacent edges'))
+        s += '{}\n'.format(fielddisplay(self, 'groundingline_resolution', 'element length near the grounding line'))
+        s += '{}\n'.format(fielddisplay(self, 'groundingline_distance', 'distance around the grounding line which elements will be refined'))
+        s += '{}\n'.format(fielddisplay(self, 'icefront_resolution', 'element length near the ice front'))
+        s += '{}\n'.format(fielddisplay(self, 'icefront_distance', 'distance around the ice front which elements will be refined'))
+        s += '{}\n'.format(fielddisplay(self, 'thicknesserror_resolution', 'element length when thickness error estimator is used'))
+        s += '{}\n'.format(fielddisplay(self, 'thicknesserror_threshold', 'maximum threshold thickness error permitted'))
+        s += '{}\n'.format(fielddisplay(self, 'thicknesserror_groupthreshold', 'maximum group threshold thickness error permitted'))
+        s += '{}\n'.format(fielddisplay(self, 'thicknesserror_maximum', 'maximum thickness error permitted'))
+        s += '{}\n'.format(fielddisplay(self, 'deviatoricerror_resolution', 'element length when deviatoric stress error estimator is used'))
+        s += '{}\n'.format(fielddisplay(self, 'deviatoricerror_threshold', 'maximum threshold deviatoricstress error permitted'))
+        s += '{}\n'.format(fielddisplay(self, 'deviatoricerror_groupthreshold', 'maximum group threshold deviatoric stress error permitted'))
+        s += '{}\n'.format(fielddisplay(self, 'deviatoricerror_maximum', 'maximum deviatoricstress error permitted'))
+        s += '{}\n'.format(fielddisplay(self, 'restart', 'indicates if ReMesh() will call before first time step'))
+        return s
     #}}}
 
-    def setdefaultparameters(self):  # {{{
-        self.hmin = 100.
-        self.hmax = 100.e3
+    def setdefaultparameters(self): #{{{
+        self.hmin = 100
+        self.hmax = 100e3
+
+        # Fields
         self.fieldname = 'Vel'
-        self.err = 3.
+        self.err = 3
+
+        # Keep metric?
         self.keepmetric = 1
+
+        # Control of element lengths
         self.gradation = 1.5
-        self.groundingline_resolution = 500.
+
+        # Other criteria
+        self.groundingline_resolution = 500
         self.groundingline_distance = 0
-        self.icefront_resolution = 500.
+        self.icefront_resolution = 500
         self.icefront_distance = 0
-        self.thicknesserror_resolution = 500.
+        self.thicknesserror_resolution = 500
         self.thicknesserror_threshold = 0
         self.thicknesserror_groupthreshold = 0
         self.thicknesserror_maximum = 0
-        self.deviatoricerror_resolution = 500.
+        self.deviatoricerror_resolution = 500
         self.deviatoricerror_threshold = 0
         self.deviatoricerror_groupthreshold = 0
         self.deviatoricerror_maximum = 0
-        self.restart = 0.
+
+        # Is restart? This calls femmodel->ReMesh() before first time step.
+        self.restart = 0
         return self
     #}}}
 
-    def checkconsistency(self, md, solution, analyses):  # {{{
+    def checkconsistency(self, md, solution, analyses): #{{{
         md = checkfield(md, 'fieldname', 'amr.hmax', 'numel', [1], '>', 0, 'NaN', 1)
         md = checkfield(md, 'fieldname', 'amr.hmin', 'numel', [1], '>', 0, '<', self.hmax, 'NaN', 1)
@@ -101,7 +110,7 @@
         md = checkfield(md, 'fieldname', 'amr.restart', 'numel', [1], '>=', 0, '<=', 1, 'NaN', 1)
         return md
-    # }}}
+   # }}}
 
-    def marshall(self, prefix, md, fid):  # {{{
+    def marshall(self, prefix, md, fid): #{{{
         WriteData(fid, prefix, 'name', 'md.amr.type', 'data', 1, 'format', 'Integer')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'hmin', 'format', 'Double')
@@ -124,3 +133,3 @@
         WriteData(fid, prefix, 'object', self, 'fieldname', 'deviatoricerror_maximum', 'format', 'Double')
         WriteData(fid, prefix, 'object', self, 'class', 'amr', 'fieldname', 'restart', 'format', 'Integer')
-    # }}}
+    #}}}
Index: issm/trunk/src/m/classes/balancethickness.js
===================================================================
--- issm/trunk/src/m/classes/balancethickness.js	(revision 25994)
+++ issm/trunk/src/m/classes/balancethickness.js	(revision 26744)
@@ -40,4 +40,7 @@
 			WriteData(fid,prefix,'object',this,'fieldname','thickening_rate','format','DoubleMat','mattype',1,'scale',1/yts);
 			WriteData(fid,prefix,'object',this,'fieldname','stabilization','format','Integer');
+
+			WriteData(fid,prefix,'object',this,'fieldname','slopex','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',this,'fieldname','slopey','format','DoubleMat','mattype',1);
 			WriteData(fid,prefix,'object',this,'fieldname','omega','format','DoubleMat','mattype',1);
 
@@ -53,5 +56,8 @@
 	this.thickening_rate   = NaN;
 	this.stabilization     = 0;
+
 	this.omega             = NaN;
+	this.slopex            = NaN;
+	this.slopey            = NaN;
 	this.setdefaultparameters();
 	//}}}
Index: issm/trunk/src/m/classes/basalforcings.m
===================================================================
--- issm/trunk/src/m/classes/basalforcings.m	(revision 25994)
+++ issm/trunk/src/m/classes/basalforcings.m	(revision 26744)
@@ -11,9 +11,4 @@
 	end
 	methods
-		function self = extrude(self,md) % {{{
-			self.groundedice_melting_rate=project3d(md,'vector',self.groundedice_melting_rate,'type','node','layer',1); 
-			self.floatingice_melting_rate=project3d(md,'vector',self.floatingice_melting_rate,'type','node','layer',1); 
-			self.geothermalflux=project3d(md,'vector',self.geothermalflux,'type','node','layer',1); %bedrock only gets geothermal flux
-		end % }}}
 		function self = basalforcings(varargin) % {{{
 			switch nargin
@@ -23,4 +18,17 @@
 					error('constructor not supported');
 			end
+		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   basal forcings parameters:'));
+
+			fielddisplay(self,'groundedice_melting_rate','basal melting rate (positive if melting) [m/yr]');
+			fielddisplay(self,'floatingice_melting_rate','basal melting rate (positive if melting) [m/yr]');
+			fielddisplay(self,'geothermalflux','geothermal heat flux [W/m^2]');
+
+		end % }}}
+		function self = extrude(self,md) % {{{
+			self.groundedice_melting_rate=project3d(md,'vector',self.groundedice_melting_rate,'type','node','layer',1); 
+			self.floatingice_melting_rate=project3d(md,'vector',self.floatingice_melting_rate,'type','node','layer',1); 
+			self.geothermalflux=project3d(md,'vector',self.geothermalflux,'type','node','layer',1); %bedrock only gets geothermal flux
 		end % }}}
 		function self = initialize(self,md) % {{{
@@ -56,12 +64,4 @@
 			end
 		end % }}}
-		function disp(self) % {{{
-			disp(sprintf('   basal forcings parameters:'));
-
-			fielddisplay(self,'groundedice_melting_rate','basal melting rate (positive if melting) [m/yr]');
-			fielddisplay(self,'floatingice_melting_rate','basal melting rate (positive if melting) [m/yr]');
-			fielddisplay(self,'geothermalflux','geothermal heat flux [W/m^2]');
-
-		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
 
@@ -69,7 +69,7 @@
 
 			WriteData(fid,prefix,'name','md.basalforcings.model','data',1,'format','Integer');
-			WriteData(fid,prefix,'object',self,'fieldname','groundedice_melting_rate','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
-			WriteData(fid,prefix,'object',self,'fieldname','floatingice_melting_rate','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
-			WriteData(fid,prefix,'object',self,'fieldname','geothermalflux','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'fieldname','groundedice_melting_rate','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',yts)
+			WriteData(fid,prefix,'object',self,'fieldname','floatingice_melting_rate','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',yts)
+			WriteData(fid,prefix,'object',self,'fieldname','geothermalflux','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',yts);
 		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
Index: issm/trunk/src/m/classes/basalforcings.py
===================================================================
--- issm/trunk/src/m/classes/basalforcings.py	(revision 25994)
+++ issm/trunk/src/m/classes/basalforcings.py	(revision 26744)
@@ -21,13 +21,11 @@
         self.setdefaultparameters()
     #}}}
-
     def __repr__(self):  # {{{
         s = '   basal forcings parameters:\n'
-        s += '{}\n'.format(fielddisplay(self, "groundedice_melting_rate", "basal melting rate (positive if melting) [m / yr]"))
-        s += '{}\n'.format(fielddisplay(self, "floatingice_melting_rate", "basal melting rate (positive if melting) [m / yr]"))
-        s += '{}\n'.format(fielddisplay(self, "geothermalflux", "geothermal heat flux [W / m^2]"))
+        s += '{}\n'.format(fielddisplay(self, 'groundedice_melting_rate', 'basal melting rate (positive if melting) [m/yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'floatingice_melting_rate', 'basal melting rate (positive if melting) [m/yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'geothermalflux', 'geothermal heat flux [W/m^2]'))
         return s
     #}}}
-
     def extrude(self, md):  # {{{
         self.groundedice_melting_rate = project3d(md, 'vector', self.groundedice_melting_rate, 'type', 'node', 'layer', 1)
@@ -36,19 +34,16 @@
         return self
     #}}}
-
     def initialize(self, md):  # {{{
         if np.all(np.isnan(self.groundedice_melting_rate)):
             self.groundedice_melting_rate = np.zeros((md.mesh.numberofvertices, ))
-            print("      no basalforcings.groundedice_melting_rate specified: values set as zero")
+            print('      no basalforcings.groundedice_melting_rate specified: values set as zero')
         if np.all(np.isnan(self.floatingice_melting_rate)):
             self.floatingice_melting_rate = np.zeros((md.mesh.numberofvertices, ))
-            print("      no basalforcings.floatingice_melting_rate specified: values set as zero")
+            print('      no basalforcings.floatingice_melting_rate specified: values set as zero')
         return self
     #}}}
-
     def setdefaultparameters(self):  # {{{
         return self
     #}}}
-
     def checkconsistency(self, md, solution, analyses):  # {{{
         if 'MasstransportAnalysis' in analyses and not solution == 'TransientSolution' and not md.transient.ismasstransport:
@@ -64,10 +59,9 @@
         return md
     # }}}
-
     def marshall(self, prefix, md, fid):  # {{{
         yts = md.constants.yts
         WriteData(fid, prefix, 'name', 'md.basalforcings.model', 'data', 1, 'format', 'Integer')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'groundedice_melting_rate', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1. / yts, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'floatingice_melting_rate', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1. / yts, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'geothermalflux', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'groundedice_melting_rate', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1 / yts, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'floatingice_melting_rate', 'format', 'DoubleMat', 'mattype', 1, 'scale', 1 / yts, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'geothermalflux', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', yts)
     # }}}
Index: issm/trunk/src/m/classes/basalforcingsismip6.m
===================================================================
--- issm/trunk/src/m/classes/basalforcingsismip6.m	(revision 25994)
+++ issm/trunk/src/m/classes/basalforcingsismip6.m	(revision 26744)
@@ -59,5 +59,5 @@
 			md = checkfield(md,'fieldname','basalforcings.gamma_0','numel',1,'NaN',1,'Inf',1,'>',0);
 			md = checkfield(md,'fieldname','basalforcings.tf_depths','NaN',1,'Inf',1);
-			md = checkfield(md,'fieldname','basalforcings.delta_t','NaN',1,'Inf',1,'numel',md.basalforcings.num_basins);
+			md = checkfield(md,'fieldname','basalforcings.delta_t','NaN',1,'Inf',1,'numel',md.basalforcings.num_basins,'size',[1,md.basalforcings.num_basins]);
 			md = checkfield(md,'fieldname','basalforcings.islocal','values',[0 1]);
 			md = checkfield(md,'fieldname','basalforcings.geothermalflux','NaN',1,'Inf',1,'>=',0,'timeseries',1);
Index: issm/trunk/src/m/classes/calving.js
===================================================================
--- issm/trunk/src/m/classes/calving.js	(revision 25994)
+++ issm/trunk/src/m/classes/calving.js	(revision 26744)
@@ -35,4 +35,5 @@
 		this.fix=function() { //{{{
 			this.calvingrate=NullFix(this.calvingrate,NaN);
+			this.meltingrate=NullFix(this.meltingrate,NaN);
 		}//}}}
 	//properties 
Index: issm/trunk/src/m/classes/calving.py
===================================================================
--- issm/trunk/src/m/classes/calving.py	(revision 25994)
+++ issm/trunk/src/m/classes/calving.py	(revision 26744)
@@ -16,20 +16,19 @@
     def __init__(self):  # {{{
         self.calvingrate = np.nan
-        self.setdefaultparameters()
-
+        #self.setdefaultparameters() # Uncomment if/when setdefaultparameters is used
     #}}}
 
     def __repr__(self):  # {{{
         s = '   Calving parameters:'
-        s += '{}\n'.format(fielddisplay(self, 'calvingrate', 'calving rate at given location [m / a]'))
+        s += '{}\n'.format(fielddisplay(self, 'calvingrate', 'calving rate at given location [m/a]'))
         return s
+    #}}}
+
+    def setdefaultparameters(self):  # {{{
+        return self
     #}}}
 
     def extrude(self, md):  # {{{
         self.calvingrate = project3d(md, 'vector', self.calvingrate, 'type', 'node')
-        return self
-    #}}}
-
-    def setdefaultparameters(self):  # {{{
         return self
     #}}}
Index: issm/trunk/src/m/classes/calvingcrevassedepth.m
===================================================================
--- issm/trunk/src/m/classes/calvingcrevassedepth.m	(revision 25994)
+++ issm/trunk/src/m/classes/calvingcrevassedepth.m	(revision 26744)
@@ -6,5 +6,6 @@
 classdef calvingcrevassedepth
 	properties (SetAccess=public) 
-		crevasse_opening_stress=1.;
+		crevasse_opening_stress=1;
+		crevasse_threshold     =1.;
 		water_height = 0.;
 	end
@@ -32,6 +33,7 @@
 		function self = setdefaultparameters(self) % {{{
 			
-			self.water_height = 0.;
-			crevasse_opening_stress=1.;
+			crevasse_threshold      = 1.;
+			crevasse_opening_stress = 1;
+         self.water_height       = 0.;
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
@@ -40,4 +42,5 @@
 
 			md = checkfield(md,'fieldname','calving.crevasse_opening_stress','numel',[1],'values',[0,1]);
+         md = checkfield(md,'fieldname','calving.crevasse_threshold','numel',[1],'>',0,'<=',1);
 			md = checkfield(md,'fieldname','calving.water_height','NaN',1,'Inf',1,'timeseries',1,'>=',0);
 		end % }}}
@@ -45,4 +48,5 @@
 			disp(sprintf('   Calving Pi parameters:'));
 			fielddisplay(self,'crevasse_opening_stress','0: stress only in the ice-flow direction, 1: max principal');
+			fielddisplay(self,'crevasse_threshold','ratio of full thickness to calve (e.g. 0.75 is for 75% of the total ice thickness)');
 			fielddisplay(self,'water_height','water height in the crevasse [m]');
 
@@ -52,4 +56,5 @@
 			WriteData(fid,prefix,'name','md.calving.law','data',6,'format','Integer');
 			WriteData(fid,prefix,'object',self,'fieldname','crevasse_opening_stress','format','Integer');
+         WriteData(fid,prefix,'object',self,'fieldname','crevasse_threshold','format','Double');
 			WriteData(fid,prefix,'object',self,'fieldname','water_height','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
 		end % }}}
Index: issm/trunk/src/m/classes/calvingcrevassedepth.py
===================================================================
--- issm/trunk/src/m/classes/calvingcrevassedepth.py	(revision 26744)
+++ issm/trunk/src/m/classes/calvingcrevassedepth.py	(revision 26744)
@@ -0,0 +1,51 @@
+from checkfield import checkfield
+from fielddisplay import fielddisplay
+#from project3d import project3d # Uncomment if/when extrude is implemented
+from WriteData import WriteData
+
+
+class calvingcrevassedepth(object):
+    """CALVINCREVASSEDEPTH class definition
+
+    Usage:
+        calvingcrevassedepth = calvingcrevassedepth()
+    """
+
+    def __init__(self):  # {{{
+        self.crevasse_opening_stress = 1
+        self.crevasse_threshold      = 1.
+        self.water_height            = 0.
+
+        #self.setdefaultparameters() # Uncomment if/when setdefaultparameters is used
+    #}}}
+    def __repr__(self):  # {{{
+        s = '   Calving Pi parameters:'
+        s += '{}\n'.format(fielddisplay(self, 'crevasse_opening_stress', '0: stress only in the ice-flow direction, 1: max principal'))
+        s += '{}\n'.format(fielddisplay(self, 'crevasse_threshold', 'ratio of full thickness to calve (e.g. 0.75 is for 75% of the total ice thickness)'))
+        s += '{}\n'.format(fielddisplay(self, 'water_height', 'water height in the crevasse [m]'))
+        return s
+    #}}}
+    def setdefaultparameters(self):  # {{{
+        return self
+    #}}}
+    def extrude(self, md):  # {{{
+        return self
+    #}}}
+    def checkconsistency(self, md, solution, analyses):  # {{{
+        #Early return
+        if solution != 'TransientSolution' or not md.transient.ismovingfront:
+            return md
+
+        md = checkfield(md, 'fieldname', 'calving.crevasse_opening_stress', 'numel', [1], 'values', [0,1])
+        md = checkfield(md, 'fieldname', 'calving.crevasse_threshold', 'numel', [1], '>', 0., '<=', 1.)
+        md = checkfield(md, 'fieldname', 'calving.water_height', 'NaN', 1, 'Inf', 1, 'timeseries', 1, '>=', 0) 
+
+        return md
+    # }}}
+    def marshall(self, prefix, md, fid):  # {{{
+        yts = md.constants.yts
+        WriteData(fid, prefix, 'name', 'md.calving.law', 'data', 6, 'format', 'Integer')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'crevasse_opening_stress', 'format', 'Integer')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'crevasse_threshold', 'format', 'Double')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'water_height', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts)
+    # }}}
Index: issm/trunk/src/m/classes/calvingdev2.m
===================================================================
--- issm/trunk/src/m/classes/calvingdev2.m	(revision 25994)
+++ issm/trunk/src/m/classes/calvingdev2.m	(revision 26744)
@@ -42,6 +42,6 @@
 			if (~strcmp(solution,'TransientSolution') | md.transient.ismovingfront==0), return; end
 
-			md = checkfield(md,'fieldname','calving.stress_threshold_groundedice','>',0,'nan',1,'Inf',1);
-			md = checkfield(md,'fieldname','calving.stress_threshold_floatingice','>',0,'nan',1,'Inf',1);
+			md = checkfield(md,'fieldname','calving.stress_threshold_groundedice','>',0,'NaN',1,'Inf',1);
+			md = checkfield(md,'fieldname','calving.stress_threshold_floatingice','>',0,'NaN',1,'Inf',1);
 			md = checkfield(md,'fieldname','calving.height_above_floatation','<=',0);
 		end % }}}
Index: issm/trunk/src/m/classes/calvingvonmises.m
===================================================================
--- issm/trunk/src/m/classes/calvingvonmises.m	(revision 25994)
+++ issm/trunk/src/m/classes/calvingvonmises.m	(revision 26744)
@@ -44,6 +44,6 @@
 			if (~strcmp(solution,'TransientSolution') | md.transient.ismovingfront==0), return; end
 
-			md = checkfield(md,'fieldname','calving.stress_threshold_groundedice','>',0,'nan',1,'Inf',1);
-			md = checkfield(md,'fieldname','calving.stress_threshold_floatingice','>',0,'nan',1,'Inf',1);
+			md = checkfield(md,'fieldname','calving.stress_threshold_groundedice','>',0,'NaN',1,'Inf',1);
+			md = checkfield(md,'fieldname','calving.stress_threshold_floatingice','>',0,'NaN',1,'Inf',1);
 			md = checkfield(md,'fieldname','calving.min_thickness','>=',0,'NaN',1,'Inf',1,'numel',1);
 		end % }}}
Index: issm/trunk/src/m/classes/calvingvonmises.py
===================================================================
--- issm/trunk/src/m/classes/calvingvonmises.py	(revision 25994)
+++ issm/trunk/src/m/classes/calvingvonmises.py	(revision 26744)
@@ -1,20 +1,18 @@
+from checkfield import checkfield
 from fielddisplay import fielddisplay
-from checkfield import checkfield
 from WriteData import WriteData
 
 
 class calvingvonmises(object):
-    """
-    CALVINGVONMISES class definition
+    """CALVINGVONMISES class definition
 
-       Usage:
-          calvingvonmises = calvingvonmises()
+    Usage:
+        calvingvonmises = calvingvonmises()
     """
 
     def __init__(self):  # {{{
-
-        self.stress_threshold_groundedice = 0.
-        self.stress_threshold_floatingice = 0.
-        self.min_thickness = 0.
+        self.stress_threshold_groundedice = 0
+        self.stress_threshold_floatingice = 0
+        self.min_thickness = 0
 
     #set defaults
@@ -24,10 +22,9 @@
 
     def __repr__(self):  # {{{
-        string = '   Calving VonMises parameters:'
-        string = "%s\n%s" % (string, fielddisplay(self, 'stress_threshold_groundedice', 'sigma_max applied to grounded ice only [Pa]'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'stress_threshold_floatingice', 'sigma_max applied to floating ice only [Pa]'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'min_thickness', 'minimum thickness below which no ice is allowed [m]'))
-
-        return string
+        s = '   Calving VonMises parameters:\n'
+        s += '{}\n'.format(fielddisplay(self, 'stress_threshold_groundedice', 'sigma_max applied to grounded ice only [Pa]'))
+        s += '{}\n'.format(fielddisplay(self, 'stress_threshold_floatingice', 'sigma_max applied to floating ice only [Pa]'))
+        s += '{}\n'.format(fielddisplay(self, 'min_thickness', 'minimum thickness below which no ice is allowed [m]'))
+        return s
     #}}}
 
@@ -37,9 +34,9 @@
 
     def setdefaultparameters(self):  # {{{
-        #Default sigma max
+        # Default sigma max
         self.stress_threshold_groundedice = 1e6
         self.stress_threshold_floatingice = 150e3
 
-        #turn off min_thickness by default.
+        # Turn off min_thickness by default
         self.min_thickness = 0.
         return self
@@ -47,6 +44,6 @@
 
     def checkconsistency(self, md, solution, analyses):  # {{{
-        #Early return
-        if solution == 'TransientSolution' or md.transient.ismovingfront == 0:
+        # Early return
+        if solution == 'TransientSolution' or not md.transient.ismovingfront:
             return
 
